/*********************************************************************
 * This file is part of the PRAPI library.
 *
 * Copyright (C) 2001 Topi Menp
 * All rights reserved.
 *
 * This program is free software. You can redistribute and/or modify
 * it under the terms of the free software licence found in the
 * accompanying file "COPYING". The licence terms must always be
 * redistributed with this source file. The above copyright notice
 * must be reproduced in all modified and unmodified copies of this
 * source file.
 *
 * $Revision: 1.3 $
 *********************************************************************/

#include "Gaussian.h"

#include <math.h>

using namespace util;

namespace prapi
{
	Matrix<double> Gaussian::createSymmetricalGaussian(double radius, int size, double width)
	{
		Matrix<double> result(size);
		double step = radius*2/(size-1);

		for (int i=0;i<size;i++)
			for (int j=0;j<size;j++)
				{
					double x=-radius+i*step;
					double y=-radius+j*step;
					result(i,j) = exp(-x*x-y*y)/width;
				}
		return result;
	}
}
